import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

typedef PaginatedWhen = T Function<T>();

/// A useful intermediate value that also provides an interface for quickly
/// consuming the paginated data.
class PaginatedValue<T> {
  const PaginatedValue({
    required this.snapshots,
    required this.nextPage,
    required this.hasPrevious,
    required this.hasNext,
    required this.previousPage,
  });

  final List<AsyncSnapshot<T>> snapshots;

  final bool hasPrevious;

  final bool hasNext;

  final AsyncCallback nextPage;

  final AsyncCallback previousPage;
}
