import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:flutter/material.dart';
import 'package:flutter_hooks/flutter_hooks.dart';

AsyncSnapshot<DocumentSnapshot<T>> useDocument<T>({
  required DocumentReference<T> ref,
  bool listen = false,
  bool preserveState = true,
}) {
  if (listen) {
    return useStream<DocumentSnapshot<T>>(
      ref.snapshots(),
      preserveState: preserveState,
    );
  } else {
    return useFuture(
      ref.get(),
      preserveState: preserveState,
    );
  }
}
