import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:flutter/material.dart';
import 'package:flutter_hooks/flutter_hooks.dart';

AsyncSnapshot<QuerySnapshot<T>> useQuery<T>({
  required Query<T> query,
  bool listen = false,
  GetOptions? getOptions,
  bool includeMetadataChanges = false,
  bool preserveState = true,
}) {
  if (listen) {
    return useStream<QuerySnapshot<T>>(
      query.snapshots(includeMetadataChanges: includeMetadataChanges),
      preserveState: preserveState,
    );
  } else {
    return useFuture(
      query.get(getOptions),
      preserveState: preserveState,
    );
  }
}
